/* Include files */
#include<stdio.h>
#include<stdlib.h>
#include<malloc.h>
#include<string.h>

#include<uf.h>
#include<uf_ui.h>
#include<uf_modl.h>
#include<uf_object_types.h>
#include<uf_disp.h>
#include<uf_defs.h>
#include<uf_obj.h>
#include<uf_curve.h>

static void get_error(int irc);

/**************************************************/
/************* MAIN *******************************/
/**************************************************/
void ufusr(char *param, int *retcod, int param_len)
{
/* Local variables */
   char *message = "Select Objects"; 
   char *message_1 = "Input parameters"; 
	char cue[] = "Select Dimensions";
   char title[] = "Select Dimension";
   char menu_item[3][16] = {"Number steps", "Number points", "Offset distance"}; 
   char str_1[128] = "";
	
	tag_t *objects = NULL_TAG;     
   tag_t spline_tag;          
   double params[2] = {0.0, 0.0}, points[3], u1[3], v1[3], u2[3], v2[3];
   double unit_norm[3], radii[2];
   double input_params[3] = {20.0, 20.0, 0.0}; 
   int degree = 3, periodicity = 0, num_point = 0; 
   int save_def_data = 1, j = 0, obs = 1;
   int response, count, irc, i;
	int type, subtype;
   UF_CURVE_pt_slope_crvatr_t *point_data=NULL;
   UF_UI_selection_options_t opts;
   UF_UI_mask_t mask;
/* Initialize UF */       
   UF_initialize();
/* Set selection mask */
/*
   opts.other_options = 0;
   opts.reserved = NULL;
   opts.num_mask_triples = 1;
   opts.mask_triples = &mask;
   opts.mask_triples->object_type = UF_solid_type;  
   opts.mask_triples->object_subtype = 2;
   opts.mask_triples->solid_type = UF_UI_SEL_FEATURE_ANY_FACE; 
   opts.scope = UF_UI_SEL_SCOPE_WORK_PART_AND_OCC;
*
/* Select surface */
/*  
irc = UF_UI_select_by_class(message, &opts, &response, &count, &objects);
*/
	UF_UI_select_with_class_dialog(cue, title, 
		UF_UI_SEL_SCOPE_WORK_PART_AND_OCC,
   NULL, NULL, &response, &count, &objects);
//	irc = UF_OBJ_ask_type_and_subtype(objects[0], &type, &subtype);
//	sprintf(str_1, "TYPE = %d, SUBTYPE = %d", type, subtype);
//	uc1601(str_1, TRUE);
//	if(response == 1 || response == 2) return;
//	if(!irc)
//	{
	   if(objects != NULL)
      {
  		   for(i = 0; i < count; i++)
         {
      	   UF_DISP_set_highlight(objects[i], 0);
irc = UF_OBJ_ask_type_and_subtype(objects[i], &type, &subtype);
sprintf(str_1, "TYPE = %d, SUBTYPE = %d", type, subtype);
uc1601(str_1, TRUE);
    	   }
      }
//   }
	else get_error(irc);
 /**********************************************************
 *Input parameters: input_params[0] -> Number steps,       *
 *                  input_params[1] -> Number points       *
 *                  input_params[2] -> Offset from surface *
 **********************************************************/   

   irc = uc1609(message_1, menu_item, 3, input_params, &obs);
   if(irc == 1 || irc == 2) return;
   point_data = (void*)malloc(sizeof(point_data[0]));
   if(point_data == NULL) uc1601("Not memory for allocation", TRUE);

/* Loop for ask face property and initialize array for create spline */

   for(params[1]=0.0; params[1]<=1.0; params[1]+=1.0/(input_params[0]*input_params[1]))
   {
      params[0]+=1.0/input_params[1];
      irc = UF_MODL_ask_face_props(*objects, params, points, u1, v1, 
                                    u2, v2, unit_norm, radii); 
      if(irc) get_error(irc);
      point_data[num_point].point[0] = points[0]+unit_norm[0]*input_params[2];
      point_data[num_point].point[1] = points[1]+unit_norm[1]*input_params[2];
      point_data[num_point].point[2] = points[2]+unit_norm[2]*input_params[2];
      point_data[num_point].crvatr_type = UF_CURVE_CRVATR_NONE;
      point_data[num_point].crvatr[0] = 0.0;
      point_data[num_point].crvatr[1] = 0.0;
      point_data[num_point].crvatr[2] = 0.0;
      point_data[num_point].slope[0] = 0.0;
      point_data[num_point].slope[1] = 0.0;
      point_data[num_point].slope[2] = 0.0;
      if((num_point == 0) || (params[1] >= 1.0)) 
      {
         point_data[num_point].slope_type = UF_CURVE_SLOPE_AUTO;
      }
      else 
      {
         point_data[num_point].slope_type = UF_CURVE_SLOPE_NONE;
      }
      num_point++;
      point_data = (void*)realloc(point_data, sizeof(point_data[0])*(num_point+1));
      if(point_data == NULL) uc1601("Not memory for allocation", TRUE);
   }

/* End Loop */
/* Set spline color YELLOW */

   UF_OBJ_set_def_cre_color(6);

/* Create spline */
   irc = UF_CURVE_create_spline_thru_pts(degree, periodicity, num_point, point_data, 
	  		 	                             NULL, save_def_data, &spline_tag);
   if(irc) get_error(irc);
/* Free allocated memory */
   free(point_data);
   UF_free(objects);
/* Terminate program */
   UF_terminate();
}

/* Unload shared image from memory */
extern int ufusr_ask_unload(void){return (UF_UNLOAD_IMMEDIATELY);}

/* Function get error from error code */
static void get_error(int irc)
{
   char err_msg[UF_UI_MAX_STRING_LEN+1];
   char msg[133], fail_message[133];
   int  len;
   UF_get_fail_message(irc, fail_message);
   sprintf(err_msg, "error %d: %s", irc, fail_message);
   len = strlen(err_msg);
   len = (len < 131) ? len : 131;
   strncpy (msg, err_msg, len);
   msg[len+1] = '\000';
   uc1601(err_msg, TRUE);
}
