#include<stdio.h>
#include<stdlib.h>
#include<malloc.h>
#include<uf.h>
#include<uf_ui.h>
#include<uf_modl.h>
#include<uf_object_types.h>
#include<uf_disp.h>
#include<uf_defs.h>
#include<uf_obj.h>
#include<uf_part.h>
#include<uf_assem.h>

static void get_error(int irc);

void ufusr(char *param, int *retcod, int param_len)
{
	char *base_part_name = "base_part", *assem_part_name = "assem_part";
	char *refset_name = NULL, *instance_name = NULL;
	char h_value[128], error[133];
	char inp_values[2][31]={"0.5", "0.1"};
	char *message = "Select Objects";
	char *message1 = "Input values";
	char menu_list[2][16]={"Disgrace","Rough"};

	double origin[] = {0.0, 0.0, 0.0};
	double abs_csys[] = {1.0, 0.0, 0.0, 0.0, 1.0, 0.0};
	double offset_x, offset_x1, offset_x2;
	double initial_d[2]={0.0, 0.0};

	tag_t *objects, *objects_1;
	tag_t base_part_tag, assem_part_tag;
	tag_t inst_tag, block_tag, prom_feat_tag;
	tag_t *part_occs, dump_tag;
	tag_t base_body, prom_body, solid_occ;
	tag_t p_1, face_id=0, face_i=0, offset_id=0;

	uf_list_p_t list_faces;
	uf_list_p_t list_f;
	UF_PART_load_status_t load_status;
	uf_list_p_t face_list;
	UF_UI_selection_options_t opts;
	UF_UI_mask_t mask;

	int type_item[2]={300, 300};
	int add_1, unhighlight=0, face_count;
	int i, index, count, layer = 0, irc = 0, int_i[2]={1,1};
	int units = UF_PART_METRIC, response = UF_UI_OK;
	unsigned int add_2, *face_new;

	UF_initialize();

	opts.other_options = 0;
	opts.reserved = NULL;
	opts.num_mask_triples = 1;
	opts.mask_triples = &mask;
	opts.mask_triples->object_type = UF_solid_type;  
	opts.mask_triples->object_subtype = 0;
	opts.mask_triples->solid_type = UF_UI_SEL_FEATURE_BODY;
	opts.scope = UF_UI_SEL_SCOPE_WORK_PART_AND_OCC;

	irc = UF_UI_ask_create_part_filename(assem_part_name, &units, &response);
	if(irc) get_error(irc);

	irc = UF_PART_new(assem_part_name, METRIC, &assem_part_tag);
	if(irc) get_error(irc);

	irc = UF_UI_ask_create_part_filename(base_part_name, &units, &response);
	if(irc) get_error(irc);

	base_part_tag = UF_PART_ask_part_tag(base_part_name);

	UF_ASSEM_add_part_to_assembly(assem_part_tag, base_part_name, refset_name,
	instance_name, origin, abs_csys, layer, &inst_tag, &load_status);

	irc = UF_UI_select_by_class(message,&opts,&response,&count,&objects_1);
	if(!irc)
	{
  		if (objects != NULL)
  		{
  			for (i=0; i < count; i++)
    		{
      	   FTN(uf1640)(&objects_1[i],&unhighlight); 
    		}
  		}
	}
	else 
	{
  		UF_get_fail_message(irc,error);
  		printf("ERROR: %s\n",error);
	}
	p_1 = objects_1[0];
	UF_MODL_ask_feat_body(p_1, &base_body);
	printf("FEAT OK\n");
	irc = UF_ASSEM_ask_occs_of_part(assem_part_tag, base_part_tag, &part_occs);
	if(irc != 1) get_error(irc);

	solid_occ = UF_ASSEM_find_occurrence(part_occs[0], base_body);
	if(solid_occ == NULL_TAG)
	if(irc)get_error(solid_occ);

	printf("FIND OK\n");		
	irc = UF_MODL_create_promotion(solid_occ, objects);
	if(irc)get_error(irc);

	irc = UF_MODL_ask_body_faces(*objects, &list_faces);
	if(irc)get_error(irc);

	irc = UF_MODL_ask_list_count(list_faces, &face_count);
	if(irc)get_error(irc);

	irc = UF_MODL_delete_list(&list_faces);
	if(irc)get_error(irc);

	irc = uc1613(message1, menu_list, 2, int_i, initial_d, inp_values, type_item);
	offset_x1 = atof(inp_values[0]);
	offset_x2 = atof(inp_values[1]);
	offset_x = offset_x1 + offset_x2;
	sprintf(h_value, "%lf", offset_x);
	irc = UF_MODL_create_hollow(h_value, list_faces, &offset_id);
	if(irc)get_error(irc);

	irc = UF_OBJ_set_def_cre_color(5);
	if(irc)get_error(irc);

	irc = UF_MODL_ask_feat_faces(offset_id, &list_f);
	if(irc)get_error(irc);

	irc = UF_MODL_ask_list_count(list_f, &face_count);
	if(irc)get_error(irc);

	face_new = (unsigned int*) calloc(face_count, sizeof(unsigned int)); 
	if(face_new == NULL)
	{
		  uc1601("Cannot alocate memory space, too many faces", 1);
	}
	for(index = 0; index < face_count; index++) 
	{
		UF_MODL_ask_list_item(list_f, index, &face_id);
		irc = UF_MODL_extract_face(face_id, 0, &face_i);
		if(irc)get_error(irc);
		face_new[index] = face_i;
	}
	irc = UF_OBJ_set_blank_status(*objects, UF_OBJ_BLANKED);
	if(irc)get_error(irc);
	
	add_1 = 2;
	
	FTN(uf6506)(face_new, &face_count, &add_1, &add_2);
	if(add_2)
	{
		uc1601("Electrod created succesfull", 1);
	}
	else
	{
		uc1601("Sew sheet created", 1);
	}	
	free(face_new);
	irc = UF_MODL_delete_list(&list_f); 
	if(irc)get_error(irc);

	UF_free(objects); 
	UF_terminate();
}
int ufusr_ask_unload(void)
{
  return (UF_UNLOAD_IMMEDIATELY);
}

static void get_error(int irc)
{
   char err_msg[UF_UI_MAX_STRING_LEN+1];
   char msg[133], fail_message[133];
   int  len;
   UF_get_fail_message(irc, fail_message);
   sprintf(err_msg, "error %d: %s", irc, fail_message);
   len = strlen(err_msg);
   len = (len < 131) ? len : 131;
   strncpy (msg, err_msg, len);
   msg[len+1] = '\000';
   uc1601(err_msg, TRUE);
}