/*===========================================================================

	  Copyright 1997 (c) Electronic Data Systems Corporation
	                Moscow Office 
	        Unpublished - All rights reserved
                   PROGRAM NAME:  mc800_3d.c
                   AUTHOR:        Chizh Oleg
                   CREATION DATE: 20-03-1997 
		   VERSION:       1.0
===========================================================================*/
/***************************************************************************
 *                                                                         *
 * This is a C program written for Internal User Function.                 *
 * Its is postprocessor mit 3D Radius correctur for                        *
 * NC machin with controller FIDIA-20                                      *
 *                                                                         *
 *                                                                         *
 ***************************************************************************/

/* * * Include files * * */

#define M_PI 3.14159265358979

#define STEP1 18

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <malloc.h>
#include <fcntl.h>
#include <errno.h>
#include <math.h>
#include <ctype.h>
#include <wchar.h>
#include <uf.h>
#include <uf_cfi.h>
#include <uf_ui.h>
#include <uf_object_types.h>
#include <uf_disp.h>
#include <uf_modl.h>
#include <uf_curve.h>
#include <uf_defs.h>
#include <uf_exit.h>
#include <uf_csys.h>
#include <uf_obj.h>
#include <uf_part.h>
#include <uf_cam.h>
#include <uf_udop.h>
#include <uf_oper.h>
#include <uf_path.h>
/* Global variable */

void delete_right_zero(char *s);

char filein[128] = "\0";
char fileout[128];
char nc_block_in[128], nc_block_out[128];
char start_str[128], end_str[128];

/***************************************/
/*********** Main **********************/
/***************************************/

void ufusr(char *param, int *retcod, int param_len)
{
/* Declaration Variables */

char *filter = "*.cls";
char *s1;
char COMMAND[3];
char *go="GOTO/", *gohome="GOHOME/", *rapid="RAPID", *fedrat="FEDRAT/MMPM,";
char *fedrat1="FEDRAT/", *tool="LOAD/TOOL,", *col_on="COOLNT/ON";
char *col_off="COOLNT/OFF", *spin_on="SPINDL/RPM,", *spin_off="SPINDL/OFF";
char *cutcom_on = "CUTCOM/ON", *cutcom_off = "CUTCOM/OFF";
char *progid = "PROGID/";
char block[128],block1[128], str_tmp[128];
char menu[1][16]={"Tool life in min"}; 
char output[1][31]={" "};
char *message = "Input time for tool life in minuts";
int type_items[1]={200};
int points[1]={1};
double input_d[1] = {10.0};
char *message_1 = "Input parameters of operation";
char menu_1[2][16] = {"PART THICKNESS","SCALLOP HEIGHT"}; 
int points_1[2]={1,1}; 
double input_d_1[2]={1.0,0.07};
char output_1[2][31]={"1", "1"}; 
int type_items_1[2]={200,200};
char menu1[2][38]={"Accept Default Direction","Reverse Default Direction"};
char *menu1_mes="Select Normal direction";
char error[133];
char *mes_vector="Select vector for retracting";
double STEP2;
double rp[3], rp1[3], rp2[3], p[3], pout[3], norm[3], du[3], dv[3], par[2];
double fed, x, y, z;
double x_old, y_old, z_old;
double point_x, point_y;
double point_z;
double norm_out[3];
double distance, distance_old = 50;
double direction[3], origin[3];
int speed;
int chin, chout, irc, len_str, file_pos;
int in, out, c, k, rap, tol_num, resp, delta;
int i=1, j=1, off=0, shift=12, yes=6, dir1=0, num_prog=1000;
int nor_dir[200], a[3];
int type[3]={300,300,100};
int control=0, control1=0;
int units = UF_PART_METRIC;
int response = UF_UI_OK;
int delta_deg; 
double delta_z;
int rapid_move = 0, lin_move = 1;
int t1, st2, tag_num;
tag_t *surface;
int mode_vector=UF_UI_ZC_AXIS;
int resp_vector=UF_UI_OK;
double time_life=0, distance_calc=0, tool_path=0;
double t_1[5];
int steps;
double x_cal=0.0, y_cal=0.0, z_cal=0.0;
double x_cal_old=0.0, y_cal_old=0.0, z_cal_old=0.0;
/* double rp3[6]={0.0, 0.0, 0.0, 100.0, 100.0, 100.0}; */
double rp3[6];
double tmp_doub[6]={0.0,0.0,0.0,0.0,0.0,0.0};
tag_t part; 
char part_fspec[MAX_FSPEC_SIZE+1];
char   op_name[20];
char   str_tmp_1[128];
double d_x, d_y, d_z;

UF_UI_selection_options_t opts;
UF_UI_mask_t mask;

UF_initialize();

opts.other_options=0;
opts.reserved=NULL;
opts.num_mask_triples=1;
opts.mask_triples = &mask;
opts.mask_triples -> object_type=UF_solid_type;
opts.mask_triples -> object_subtype=0;
opts.mask_triples -> solid_type=UF_UI_SEL_FEATURE_ANY_FACE;
opts.scope=UF_UI_SEL_SCOPE_WORK_PART_AND_OCC;

/* Select surface for manufacturing */

control=UF_UI_select_by_class("Select faces", &opts, &k, &c, &surface);
if(c==0)
{
	UF_get_fail_message(control, error);
}
if(k==1 || k==2) return;
par[0]=0.5, par[1]=0.5;
for(delta=0, dir1=0 ; delta < c; delta++)
{
	FTN(uf5911)(surface+delta, par, pout, du, dv, norm);
	FTN(uf5406)(surface+delta,&j);
	tag_num = *surface+delta;
	UF_OBJ_ask_type_and_subtype(tag_num, &t1, &st2);
	UF_DISP_conehead(-3, pout, norm, 0);
	resp = uc1603(menu1_mes, yes, menu1, 2); 
	switch(resp)
	{
	   case 1: exit;
		   break; 
	   case 2: return;
		   break;
	   case 6:  norm[0] = -norm[0],norm[1] = -norm[1],norm[2] = -norm[2];
				UF_DISP_refresh();
				UF_DISP_conehead(0, pout, norm,0);
				nor_dir[dir1]=1;
				FTN(uf1640)(surface+delta,&off);
				break;
	   default:nor_dir[dir1]=0; 
	}
	dir1++;
	UF_DISP_refresh();
	FTN(uf1640)(surface+delta,&off);
}

a[2]=1000;
UF_UI_set_dialog_filter(UF_UI_PART_NEW_FLTR, filter);

/* Select CLS file for Postprocessing */

irc = UF_UI_ask_create_part_filename(filein, &units, &response);
if(irc)
{
   UF_get_fail_message(irc,error);
   uc1601(error, 1);
   exit(1);
}

/* Convert string file name to ptp and dnc file and running GPM */

len_str = strlen(filein);
strncat(fileout, filein, (len_str-3));
strcat(fileout, "ptp");

irc = uc1613(message, menu, 2, points, input_d,
output, type_items);
STEP2 = input_d[2]/10;
chin=uc4504(filein,1,2004);
chout=uc4504(fileout,3,2004); 

file_pos = uc4534(chin);
while((in=uc4514(chin, block) >= 0))
{
   while((s1 = strstr(block, fedrat)) != NULL)
   {
      sscanf(s1+shift, "%lf", &fed); 
      break;
   }
}
uc4535(chin, file_pos);
for(delta=0, dir1=0 ; delta < c; delta++)
{
	while((in=uc4514(chin, block) >= 0))
	{
           if((s1 = strstr(block, "TOOL PATH/")) != NULL)
           {
              strcpy(str_tmp_1, s1+10); 
           }
	   if((s1 = strstr(block, progid)) != NULL) 
	   { 
	      sscanf(s1+7, "%d", &num_prog);
	      sprintf(block1,"N%dG17Q1", i++);
	      out=uc4524(chout,block1);
	      sprintf(block1,"N%dG54", i++);
	      out=uc4524(chout,block1);
              part = UF_PART_ask_display_part();
              UF_PART_ask_part_name(part, part_fspec);
              sprintf(block1, "N%d (MODEL = %s)", i++, part_fspec);
	      out=uc4524(chout,block1);
              sprintf(block1, "N%d (NC SET = %s)", i++, str_tmp_1);
	      out=uc4524(chout,block1);
              irc = uc1613(message, menu_1, 2, points_1, input_d_1, output_1, type_items_1);
              sprintf(block1, "N%d (PART SURFACE THICKNESS = %.3lf)", i++, input_d_1[0]);
	      out=uc4524(chout,block1);
              sprintf(block1, "N%d (MAXIMUM SCALLOP HEIGHT = %.3lf)", i++, input_d_1[1]);
	      out=uc4524(chout,block1);
 	   }
           if((s1 = strstr(block, "TLDATA/MILL,")) != NULL)
           {
              sscanf(s1+12, "%lf,%lf,%lf,%lf,%lf", &t_1[0], &t_1[1], &t_1[2], &t_1[3], &t_1[4]);
           }
	   if((s1 = strstr(block, tool)) != NULL) 
	   { 
		sscanf(s1+10, "%d", &tol_num);
		sprintf(block1,"N%dT%dM6(D=%.3lf R=%.3lf)",i++,tol_num, t_1[0], t_1[1]);     
		out=uc4524(chout,block1);
	   }
	   if((s1 = strstr(block, col_on)) != NULL) 
	   { 
		sprintf(block1,"N%dM7",i++);     
		out=uc4524(chout,block1);
	   }
	   if((s1 = strstr(block, spin_on)) != NULL) 
	   { 
		sscanf(s1+11, "%d", &speed);
		sprintf(block1,"N%dS%dM3",i++,speed);     
		out=uc4524(chout,block1);
	   }
	   if((s1 = strstr(block, col_off)) != NULL) 
	   { 
		sprintf(block1,"N%dM9",i++);     
		out=uc4524(chout,block1);
	   }
	   if((s1 = strstr(block, spin_off)) != NULL) 
	   { 
		sprintf(block1,"N%dM5",i++);     
		out=uc4524(chout,block1);
	   }
	   if((s1 = strstr(block, gohome)) != NULL) 
	   { 			
		sscanf(s1+7, "%lf,%lf,%lf", &x,&y,&z);
		sprintf(str_tmp,"X%.3lfY%.3lfZ%.3lf",i++,x,y,z);
                delete_right_zero(str_tmp); 
		sprintf(block1,"N%dG0%s",i++,str_tmp);
		out=uc4524(chout,block1);
	   } 
	   if((s1 = strstr(block, rapid)) != NULL) 
	   { 
		rap=1;
	   }
	   if((s1 = strstr(block, fedrat)) == NULL)
	   { 
	      if((s1 = strstr(block, fedrat1)) != NULL)
	      {
	          strcpy(fedrat, fedrat1);
		  shift = shift-5;
	      }
  	   }
	   if((s1 = strstr(block, fedrat)) != NULL)
	   {
	  	  sscanf(s1+shift, "%lf", &fed); 
	   }
	   if((s1 = strstr(block, cutcom_on)) != NULL)
	   {
		   rap=0; 		   
		   sprintf(str_tmp,"G44F%.3lf", fed);
		   delete_right_zero(str_tmp);      
		   sprintf(block1,"N%d%s", i++, str_tmp);
		   out=uc4524(chout,block1);
	   }
	   if((s1 = strstr(block, cutcom_off)) != NULL)
	   {
		   rap=0; 
		   sprintf(block1,"N%dG40",i++);     
		   out=uc4524(chout,block1);
	    }
	    if((s1 = strstr(block, go)) != NULL && !rap)
	    { 
	       sscanf(s1+5, "%lf,%lf,%lf", &x,&y,&z);
	       rp[0]=x,rp[1]=y,rp[2]=z;
               x_cal=rp1[0]; y_cal=rp1[1]; z_cal=rp1[2];
               UF_CSYS_map_point(UF_CSYS_ROOT_WCS_COORDS, rp,
               UF_CSYS_ROOT_COORDS, rp1);

               distance_calc=sqrt((rp1[0]-x_old)*(rp1[0]-x_old)+
                                  (rp1[1]-y_old)*(rp1[1]-y_old)+
                                  (rp1[2]-z_old)*(rp1[2]-z_old));
               tool_path += distance_calc;
               time_life=tool_path/fed;
               if(time_life >= input_d[0])
               {
                  file_pos = uc4534(chin);
                  sprintf(block1, "N%d(END OFF TOOL LIFE)", i++);
		  out=uc4524(chout,block1);
                  sprintf(block1, "N%d (START RETRACTION MOVE)", i++);
		  out=uc4524(chout,block1);
                  for(steps = 0; steps < 5; steps++)
                  {
	             uc4514(chin, block);
                     sscanf(s1+5, "%lf,%lf,%lf", &x,&y,&z);
                     rp[0]=x,rp[1]=y,rp[2]=z;
                     UF_CSYS_map_point(UF_CSYS_ROOT_WCS_COORDS, rp,
                     UF_CSYS_ROOT_COORDS, rp1);
                     rp3[0]=x_cal; rp3[1]=y_cal; rp3[2]=z_cal;
                     rp3[3]=x_cal_old; rp3[4]=y_cal_old; rp3[5]=z_cal_old;
                     uc2721(" ", 1, rp3, 0, 1, 0); 
                     rp1[2]+=0.2;
                     sprintf(str_tmp,"G1X=%.3lfY=%.3lfZ=%.3lfDX=%.2lfDY=%.3lfDZ=%.3lf",
	             rp1[0],rp1[1],rp1[2],norm[0],norm[1],norm[2]);
	             delete_right_zero(str_tmp);      
	             sprintf(block1,"N%d%s", i++, str_tmp);
		     out=uc4524(chout,block1);
                  } 
/*
                  rp2[0]=x_cal; rp2[1]=y_cal; rp2[2]=z_cal;
                  norm[0]=-norm[0]; norm[1]=-norm[1]; norm[2]=-norm[2];
	          UF_DISP_conehead(-1, rp2, norm, 0);
*/
                  UF_UI_specify_vector(mes_vector, &mode_vector, UF_UI_DISP_TEMP_VECTOR, 
                  direction, origin, &resp_vector);

/* output menu corresponding direction of retract */

/* output menu for input point of retract */

                  UF_DISP_refresh();

                  sprintf(block1, "N%d (END RETRACTION MOVE)", i++);
		  out=uc4524(chout,block1);
                  sprintf(block1, "N%dG40", i++);
		  out=uc4524(chout,block1);

                  sprintf(block1,"N%dG91Z100", i++); 
		  out=uc4524(chout,block1);

                  sprintf(block1, "N%dM0", i++);
		  out=uc4524(chout,block1);
                  sprintf(block1, "N%d(T%d)", i++, tol_num++);
		  out=uc4524(chout,block1);
                  sprintf(block1, "N%dG44F%.3lf", i++, fed);
		  out=uc4524(chout,block1);
                  tool_path=0.0;
                  time_life=0.0;
                  distance_calc=0.0;
                  uc4535(chin,file_pos);
               }
	       if(input_d[1] == input_d[0])
	       {
	          for(delta_z = 0; delta_z < input_d[0]; delta_z += STEP2)
	          {
	             for(delta_deg = 0; delta_deg <= 360; delta_deg += STEP1)
	             {			   	  
	   	        UF_MODL_ask_face_parm(surface[delta], rp1, par, p);
	                FTN(uf5911)(surface+delta, par, pout, du, dv, norm_out);
	                point_x = rp1[0]+((input_d[0]-delta_z)/2)*cos(delta_deg/180*M_PI); 
		        point_y = rp1[1]+((input_d[0]-delta_z)/2)*sin(delta_deg/180*M_PI);
		        point_z = rp1[2]+delta_z;
		        distance = sqrt(pow(pout[0]-point_x,2)+ 
	                pow(pout[1]-point_y,2)+
	                pow(pout[2]-point_z,2));
		        if(distance < distance_old)
		        {
		           norm[0] = norm_out[0];
	  	           norm[1] = norm_out[1];
		           norm[2] = norm_out[2];
		           distance_old = distance;
		        }
	            }
		}
	     }
	     else
	     {
	        for(delta_deg = 0; delta_deg <= 360; delta_deg += STEP1)
	        {
	           UF_MODL_ask_face_parm(surface[delta], rp1, par, p);
	           FTN(uf5911)(surface+delta, par, pout, du, dv, norm_out);
		   point_x = rp1[0]+(input_d[0]/2)*cos(delta_deg/180*M_PI); 
		   point_y = rp1[1]+(input_d[0]/2)*sin(delta_deg/180*M_PI);
		   distance = sqrt(pow(pout[0]-point_x,2)+pow(pout[1]-point_y,2));
	 	   if(distance < distance_old)
	 	   {
		     norm[0] = norm_out[0];
		     norm[1] = norm_out[1];
		     norm[2] = norm_out[2];
		     distance_old = distance;
		   }
		}
	     }
	     if(nor_dir[dir1]==1) 
	     {
	        norm[0] = -norm[0],norm[1] = -norm[1],norm[2] = -norm[2];
	        sprintf(str_tmp, "X%.3lfY%.3lfZ%.3lfDX%.3lfDY%.3fDZ%.3lf",
	        x,y,z,norm[0],norm[1],norm[2]);
	        delete_right_zero(str_tmp);      
	        sprintf(block1,"N%dG1%s", i++, str_tmp);
	        out=uc4524(chout,block1);
	        distance_old = 50;
	        lin_move = 0;
	     } 
	     else
	     {  	   		   
	        sprintf(str_tmp, "X%.3lfY%.3lfZ%.3lfDX%.3lfDY%.3fDZ%.3lf",
	        x,y,z,norm[0],norm[1],norm[2]);
	        delete_right_zero(str_tmp); 
	        sprintf(block1,"N%dG1%s",i++,str_tmp);     
	        out=uc4524(chout,block1);
	        distance_old = 50;
	        lin_move = 0;
	     }
	  }
	  if(s1 != NULL && rap)
	  {
	     strcpy(COMMAND, "G0");
	     sscanf(s1+5, "%lf,%lf,%lf", &x,&y,&z);
	     sprintf(str_tmp, "X%.3lfY%.3lfZ%.3lf",x, y, z);
	     delete_right_zero(str_tmp);      
	     sprintf(block1,"N%d%s%s", i++, COMMAND, str_tmp);     
	     out=uc4524(chout,block1);
	     distance_old = 50;
	     rapid_move = 0;
	  }
    }
    dir1++;
    x_old=rp1[0]; y_old=rp1[1]; z_old=rp1[2];
}
sprintf(block1,"N%dM30",i++);     
out=uc4524(chout,block1);
FTN(uf1640)(surface+delta, &off);
UF_DISP_refresh();
UF_free(surface); 
uc4540(chin,0);
uc4540(chout,0);
uc1601("Post Processing Finished", 1);
filter = "*.prt";
UF_UI_set_dialog_filter(UF_UI_PART_NEW_FLTR, filter);
UF_terminate();
}

/* End of main program */

/* Function unload shared image from memory immediatly */

int ufusr_ask_unload(void)
{
  return (UF_UNLOAD_IMMEDIATELY);
}  

/* This function deletes all '0' at end of number */

void delete_right_zero(char *s) 
{
   int n, i, j, can_delete;
   char s1[200];

   n = strlen(s);
   can_delete = 1;  for (i=0; i<200; i++) s1[i] = '\0';
   for (i=n-1,j=0; i>=0; i--)
   {
     if (s[i]== '0' && can_delete) continue;
	 if (s[i]== '.' && can_delete) 
	 { 
	    can_delete=0; continue; 
	 }
	 if (isdigit(s[i]) && s[i]!= '0') can_delete = 0;
	 s1[j]=s[i]; j++; 
	 if (!isdigit(s[i]) && s[i]!= '.') can_delete = 1;
   }
   n=strlen(s1);
   for (i=0; i<n; i++) s[i] = s1[n-1-i]; s[n]= '\0';
}
