/*===========================================================================

	  Copyright 1996 (c) Electronic Data Systems Corporation
	                Moscow Office 
	        Unpublished - All rights reserved
                   PROGRAM NAME:  fidia_3d.c
                   AUTHOR:        Chizh Oleg
                   CREATION DATE: 19-June-1996 
		   VERSION:       1.0
===========================================================================*/
/***************************************************************************
 *                                                                         *
 * This is a C program written for Internal User Function.                 *
 * Its is postprocessor mit 3D Radius correctur for                        *
 * NC machin and controller FIDIA CNC 20/40                                *
 *                                                                         *
 *                                                                         *
 ***************************************************************************/
/* * * Include files * * */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <uf.h>
#include <uf_cfi.h>
#include <uf_ui.h>
#include <uf_object_types.h>
#include <uf_disp.h>
#include <uf_modl.h>
#include <uf_ui_xt.h>
#include <uf_curve.h>
#include <uf_exit.h>
#include <Xm/XmAll.h>
#include <fcntl.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <X11/Xatom.h>
#include <X11/Intrinsic.h>
#include <X11/Shell.h>
#include <Xm/Xm.h>
#include <Xm/XmP.h>
#include <Xm/CascadeB.h>
#include <Xm/DialogS.h>
#include <Xm/BulletinB.h>
#include <Xm/FileSB.h>
#include <Xm/MainW.h>
#include <Xm/MessageB.h>
#include <Xm/Label.h>
#include <Xm/PushB.h>
#include <Xm/RowColumn.h>
#include <Xm/SelectioB.h>
#include <Xm/Text.h>
#include <Xm/CutPaste.h>  
          
#define DIALOG_FSELECT		0

static void Select (Widget w, XtPointer client_data,
                        XmAnyCallbackStruct *call_data);
void Select1 ();
void Select2 ();
static void ReadCB();                   
static void ReadCB1(); 
static void DialogCancelCB(); 

typedef struct {
    Widget work_area  ;
    Widget v_scrb ;
    String file_name ;
    XFontStruct * font_struct ;
    GC draw_gc ;
    char ** lines ;
    int num_lines ;
} FileData ;

static void uf_persistent (void);
Widget fsb_box = NULL ;                       

static UF_UI_menubar_item_t menu[] =  {
{UF_UI_MENU,  " Postprocess "  , "BM_USER",FALSE, NULL , NULL },
               
{UF_UI_PUSH , "FIDIA 5 AXIS" ,"USER_PULLDOWN1",TRUE,(XtCallbackProc)Select1,NULL},
{UF_UI_PUSH , "FIDIA 3 AXIS" ,"USER_PULLDOWN1",TRUE,(XtCallbackProc)Select2,NULL},
{UF_UI_PUSH , "3D RADIUS CORRECTUR" ,"USER_PULLDOWN1",TRUE,(XtCallbackProc)Select,NULL},
      
UF_UI_END_MENU
      
};

void ufusr(char *param, int *retcod, int param_len)

{
   (void)UF_initialize(); 
   (void)UF_UI_append_menubar_menu(menu, NULL, NULL);
}

/***************************************/
/*********** Main **********************/
/***************************************/

static void Select (Widget w, XtPointer client_data,
                     XmAnyCallbackStruct *call_data)
/* Declaration Variables */
{
char *filein; 
char *fileout;
char *s1;
char *go="GOTO/";
char *gohome="GOHOME/";
char *rapid="RAPID";
char *fedrat="FEDRAT/MMPM,";
char *fedrat1="FEDRAT/";
char *tool="LOAD/TOOL,";
char *col_on="COOLNT/ON";
char *col_off="COOLNT/OFF";
char *spin_on="SPINDL/RPM,";
char *spin_off="SPINDL/OFF";
char block[128],block1[128];
char menu[3][16]={"Name CLS File->", "Name PTP File->", "Num CNC Progr->"}; 
char output[3][31]={" "," "};
char menu1[2][38]={"Accept Default Direction","Reverse Default Direction"};
char *menu1_mes="Select Normal direction";
char error[133];

double b[3], rp[3], p[3], pout[3], norm[3], du[3], dv[3], par[2];

int chin, chout;
int in, out, c, k, rap, tol_num, resp, display, delta;
int i=1, j=1, off=0, shift=12, yes=6, dir1=0, num_prog=1000;
int nor_dir[200], a[3];
int type[3]={300,300,100};
int control=0;
int control1=0;
int return_code;

float fed, speed, x, y, z;

tag_t *surface;

UF_UI_selection_options_t opts;
UF_UI_mask_t mask;
return_code = UF_UI_lock_ug_access( UF_UI_FROM_CUSTOM );
/* UF_initialize(); */

opts.other_options=0;
opts.reserved=NULL;
opts.num_mask_triples=1;
opts.mask_triples = &mask;
opts.mask_triples -> object_type=UF_solid_type;
opts.mask_triples -> object_subtype=0;
opts.mask_triples -> solid_type=UF_UI_SEL_FEATURE_ANY_FACE;
opts.scope=UF_UI_SEL_SCOPE_WORK_PART_AND_OCC;

/* Select surface for manufacturing */

control=UF_UI_select_by_class("Select faces", &opts, &k, &c, &surface);
if(c==0)
{
	UF_get_fail_message(control, error);
}
if(k==1 || k==2) return;

par[0]=0.5, par[1]=0.5;
for(delta=0,dir1=0 ; delta < c; delta++)
{
	FTN(uf5911)(surface+delta, par, pout, du, dv, norm);
	FTN(uf5406)(surface+delta,&j);
	UF_DISP_conehead(0, pout, norm,0);
	uc4400(0," ",1);
	FTN(uf4401)(&display);
	resp = uc1603(menu1_mes, yes, menu1, 2); 
	switch(resp)
	{
	   case 1: exit;
		   break; 
	   case 2: return;
		   break;
	   case 6: norm[0] = -norm[0],norm[1] = -norm[1],norm[2] = -norm[2];
				UF_DISP_refresh();
				UF_DISP_conehead(0, pout, norm,0);
				nor_dir[dir1]=1;
				FTN(uf1640)(surface+delta,&off);
				break;
	   default:nor_dir[dir1]=0; 
	}
/*	if(resp == 6)
	{
		norm[0] = -norm[0],norm[1] = -norm[1],norm[2] = -norm[2];
		UF_DISP_refresh();
		UF_DISP_conehead(0, pout, norm,0);
		nor_dir[dir1]=1;
		FTN(uf1640)(surface+delta,&off);
	} 
	else nor_dir[dir1]=0; */
	dir1++;
	UF_DISP_refresh();
	FTN(uf1640)(surface+delta,&off);
}

a[2]=1000;
control1=uc1613("Input Parameters", menu, 3, a, b, output, type);	
if(control1==1) exit;
if(control1==2) return;
filein=output[0],fileout=output[1],num_prog=a[2]; 
chin=uc4504(filein,1,2004);
chout=uc4504(fileout,3,2004); 
if(i==1)
{ 
	sprintf(block1,"%%%d",num_prog);
	out=uc4524(chout,block1);
}
sprintf(block1,"N%dG17Q1",i++);
out=uc4524(chout,block1);
for(delta=0,dir1=0 ; delta < c; delta++)
{
	while((in=uc4514(chin, block) >= 0))
	{
		s1 = strstr(block, tool);
		if(s1 != NULL) 
		{ 
			sscanf(s1+10, "%d", &tol_num);
			sprintf(block1,"N%dT%dM6",i++,tol_num);     
			out=uc4524(chout,block1);
		}
		s1 = strstr(block, col_on);
		if(s1 != NULL) 
		{ 
			sprintf(block1,"N%dM7",i++);     
			out=uc4524(chout,block1);
		}
		s1 = strstr(block, spin_on);
		if(s1 != NULL) 
		{ 
			sscanf(s1+11, "%f", &speed);
			sprintf(block1,"N%dS%.0fM3",i++,speed);     
			out=uc4524(chout,block1);
		}
		s1 = strstr(block, col_off);
		if(s1 != NULL) 
		{ 
			sprintf(block1,"N%dM9",i++);     
			out=uc4524(chout,block1);
		}
		s1 = strstr(block, spin_off);
		if(s1 != NULL) 
		{ 
			sprintf(block1,"N%dM5",i++);     
			out=uc4524(chout,block1);
		}
		s1 = strstr(block, gohome);
		if(s1 != NULL) 
		{ 
			sscanf(s1+7, "%f,%f,%f", &x,&y,&z);
			sprintf(block1,"N%dG40G00",i++);     
			out=uc4524(chout,block1);
			sprintf(block1,"N%dX%.3fY%.3fZ%.3f",i++,x,y,z);
			out=uc4524(chout,block1);
		} 
		s1 = strstr(block, rapid);
		if(s1 != NULL) 
		{ 
			rap=1; 
			sprintf(block1,"N%dG40G00",i++);     
			out=uc4524(chout,block1);
		}
		s1 = strstr(block, fedrat);
		if(s1 == NULL)
		{ 
			s1 = strstr(block, fedrat1);
			if(s1 != NULL)
			{
			strcpy(fedrat, fedrat1);
			shift=shift-5;
			}
		}
		if(s1 != NULL)
		{
			sscanf(s1+shift, "%f", &fed);
			if(rap)
			{
				rap=0; 
				sprintf(block1,"N%dG44G01F%.0f",i++,fed);     
				out=uc4524(chout,block1);
			}
			else 
			{
				sprintf(block1,"N%dF%.0f",i++,fed);
				out=uc4524(chout,block1);
			} 
		}

	s1 = strstr(block, go);
	if(s1 != NULL && !rap)
	{ 
		sscanf(s1+5, "%f,%f,%f", &x,&y,&z);
		rp[0]=x,rp[1]=y,rp[2]=z;
		UF_MODL_ask_face_parm(surface[delta], rp, par, p);
		FTN(uf5911)(surface+delta, par, pout, du, dv, norm);
		if(nor_dir[dir1]==1) 
		{
			norm[0] = -norm[0],norm[1] = -norm[1],norm[2] = -norm[2];
			sprintf(block1,"N%dX%.3fY%.3fZ%.3fDX%.3fDY%.3fDZ%.3f",i++ ,x,y,z,norm[0],norm[1],norm[2]);     
			out=uc4524(chout,block1);
		} 
		else
		{
		sprintf(block1,"N%dX%.3fY%.3fZ%.3fDX%.3fDY%.3fDZ%.3f",i++ ,x,y,z,norm[0],norm[1],norm[2]);     
		out=uc4524(chout,block1);
		}
	}
	if(s1 != NULL && rap)
	{
		sscanf(s1+5, "%f,%f,%f", &x,&y,&z);
		sprintf(block1,"N%dX%.3fY%.3fZ%.3f",i++ ,x,y,z);     
		out=uc4524(chout,block1);
	}


    }
    dir1++;
}
sprintf(block1,"N%dM30",i++);     
out=uc4524(chout,block1);
FTN(uf1640)(surface+delta,&off);
UF_DISP_refresh();
UF_free(surface); 
uc4540(chin,0);
uc4540(chout,0); 
UF_terminate();
return_code = UF_UI_unlock_ug_access( UF_UI_FROM_CUSTOM );
return;
}

void Select1 (w, client_data, call_data) 
Widget		w;		/*  widget id		*/
caddr_t		client_data;	/*  data from application   */
caddr_t		call_data;	/*  data from widget class  */
{

      if (!fsb_box) 
      {
      fsb_box = XmCreateFileSelectionDialog (w, "Select CLS file", NULL, 0);
      XtAddCallback (fsb_box, XmNokCallback, ReadCB, client_data);
      XtAddCallback (fsb_box, XmNcancelCallback, DialogCancelCB, client_data);
      }    

	XtManageChild (fsb_box); 
}

static void ReadCB (w, client_data, call_data) 
Widget		w;		/*  widget id		*/
caddr_t		client_data;	/*  data from application   */
caddr_t		call_data;	/*  data from widget class  */
{
    FileData * filedata = (FileData * ) client_data;
    String file_name ;
    Arg args[5];	
    int	n, slider_size ;	
    Dimension height ;
    char *cls_file;

    file_name = XmTextGetString(XmFileSelectionBoxGetChild(w, XmDIALOG_TEXT)) ;
    strcpy(cls_file, "/usr/eds111/mach/gpm -MDF=/users/ugii/mdf/fidia_5axis.mdfa -CLF=");
    strcat(cls_file, file_name);
    system(cls_file);
    XtUnmanageChild(fsb_box);
}

void Select2 (w, client_data, call_data) 
Widget		w;		/*  widget id		*/
caddr_t		client_data;	/*  data from application   */
caddr_t		call_data;	/*  data from widget class  */
{

      if (!fsb_box) 
      {
      fsb_box = XmCreateFileSelectionDialog (w, "Select CLS file", NULL, 0);
      XtAddCallback (fsb_box, XmNokCallback, ReadCB1, client_data);
      XtAddCallback (fsb_box, XmNcancelCallback, DialogCancelCB, client_data);
      }    

	XtManageChild (fsb_box); 
}

static void ReadCB1 (w, client_data, call_data) 
Widget		w;		/*  widget id		*/
caddr_t		client_data;	/*  data from application   */
caddr_t		call_data;	/*  data from widget class  */
{
    FileData * filedata = (FileData * ) client_data;
    String file_name ;
    Arg args[5];	
    int	n, slider_size ;	
    Dimension height ;
    char *cls_file;

    file_name = XmTextGetString(XmFileSelectionBoxGetChild(w, XmDIALOG_TEXT)) ;
    strcpy(cls_file, "/usr/eds111/mach/gpm -MDF=/users/ugii/mdf/fidia_3axis.mdfa -CLF=");
    strcat(cls_file, file_name);
    XtUnmanageChild(fsb_box);
}

static void DialogCancelCB(w, client_data, call_data) 
Widget	w;	        	/*  widget id		*/
caddr_t		client_data;	/*  data from application   */
caddr_t		call_data;	/*  data from widget class  */
{
  switch ((int)client_data)
    {
    case DIALOG_FSELECT:
      /* popdown the file selection box */
      XtUnmanageChild(fsb_box);
      break;

    default:
      /* a unknown client_data was recieved and
	 there is no setup to handle this */
      fprintf(stderr, "Warning: in cancel callback\n");
      fprintf(stderr, "Client_Data --> %d\n", client_data);
      break;
    }
}


