#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include<malloc.h>
#include<fcntl.h>
#include<errno.h>
#include<math.h>
#include<ctype.h>
#include<wchar.h>

#include<uf.h>
#include<uf_ui.h>
#include<uf_defs.h>
#include<uf_exit.h>
#include<uf_cfi.h>
#include<uf_part.h>
#include<uf_object_types.h>
#include<uf_disp.h>
#include<uf_modl.h>
#include<uf_curve.h>
#include<uf_defs.h>
#include<uf_exit.h>
#include<uf_csys.h>
#include<uf_styler.h>
#include<uf_mb.h> 

#include<uf_cam.h>
#include<uf_udop.h>
#include<uf_dpud.h>
#include<uf_drpos.h>
#include<uf_oper.h>
#include<uf_path.h>


void get_error(int irc);
void usr_params(void);

int irc = 0;
void drive_path(void);

extern void dpud(char *param, int *status, int parm_len)
{
   int i=0, j = 0;
  UF_CAM_exit_id_t  exit_id;
  UF_DPUD_id_t dpud_id;
  UF_DPUD_purpose_t purpose;

  exit_id = (UF_CAM_exit_id_t)param;

  UF_initialize();


  UF_DPUD_ask_dpud(exit_id, &dpud_id);
  UF_DPUD_ask_purpose(dpud_id, &purpose);

  if(purpose == UF_DPUD_USER_PARAMS) 
  {
      printf("\nUSER_PARMS\n");
  }
  else if(purpose == UF_DPUD_TAXIS_PARAMS) printf("TAXIS\n");
  else if(purpose == UF_DPUD_PROJ_PARAMS) printf("PROJ\n");
  else if(purpose == UF_DPUD_INIT_PROCESSOR) printf("INIT\n");
  else if(purpose == UF_DPUD_GET_USER_DATA_SIZE) 
  {
      printf("DATA\n");
      UF_DPUD_set_user_data_size(dpud_id, (sizeof(double)*18));
 
  }
  else if(purpose == UF_DPUD_GET_NEXT) 
  {
     printf("NEXT\n");
     drive_path();
  }
  else if(purpose == UF_DPUD_GET_INTERMEDIATE) 
  {
      printf("INTERMEDIATE\n");
      purpose = UF_DPUD_STOP_PROCESSOR;
  }
  else if(purpose == UF_DPUD_REWIND) printf("REWIND\n");
  else if(purpose == UF_DPUD_STOP_PROCESSOR) 
  {
      printf("STOP\n");
//      exit;
  }
  UF_terminate();
}

int ufusr_ask_unload(void)
{
  return(UF_UNLOAD_IMMEDIATELY);
}

void get_error(int irc)
{
   char err_msg[UF_UI_MAX_STRING_LEN+1];
   char msg[133];
   char fail_message[133];
   int  len;
   UF_get_fail_message(irc, fail_message);
   sprintf(err_msg, "error %d: %s", irc, fail_message);
   len = strlen(err_msg);
   len = (len < 131) ? len : 131;
   strncpy (msg, err_msg, len);
   msg[len+1] = '\000';
   uc1601(err_msg, TRUE);
}

void usr_params(void)
{
   char *message = "Input parameters for calculate feedrate";
   char menu_list[3][16]={"Profile depth", "Nose radius mm", "Feed in mm/rev"};
   char c_val[3][31]={"1","1","1"};
   int part_no[3] = {0,0,0};
   int type_item[3] = {200, 200, 200};
   double values[3] = {5.0, 1.2, 1.0};
   int irc = 0;

   while(irc !=2)
   {
      values[2] = sqrt((values[0]*8*values[1])/1000);
      irc = uc1613(message, menu_list, 3, part_no, values, c_val, type_item);
   }
}

void drive_path(void)
{
   UF_DRPOS_id_t drpos;
   UF_DRPOS_type_t type_cut;
   UF_DRPOS_feed_use_t feed;
   double pos[3]  = {0.0, 0.0, 20.0};
   double dir[3]  = {0.0, 1.0,  0.0};
   double *user_data;

   irc = UF_DRPOS_set_user_data(drpos, user_data);
   if(irc) get_error(irc);

   type_cut = UF_DRPOS_TYPE_CUT;
   irc = UF_DRPOS_set_position(drpos, pos);

   type_cut = UF_DRPOS_TYPE_FIRST_CUT;
   feed =  UF_DRPOS_FEED_USE_DEFAULT;
 
   irc = UF_DRPOS_create_first_cut(drpos, pos, dir);   
   irc = UF_DRPOS_set_position(drpos, pos);
   irc = UF_DRPOS_set_drive_direction(drpos, dir);
   pos[0] = 0.0; pos[1] = 100.0; pos[2] = 20.0;
   dir[0] = 0.0; dir[1] = 1.0;   dir[2] = 0.0;

   type_cut = UF_DRPOS_TYPE_CUT;
   irc = UF_DRPOS_create_cut(drpos, pos, dir);
   irc = UF_DRPOS_set_position(drpos, pos);

   pos[0] = 100.0; pos[1] = 10.0; pos[2] = 20.0;
   dir[0] = 1.0; dir[1] = 0.0;   dir[2] = 0.0;

   type_cut = UF_DRPOS_TYPE_FINAL_LIFT;
   irc = UF_DRPOS_create_final_lift(drpos);
   irc = UF_DRPOS_set_position(drpos, pos);
   printf("USER_DATA = %d\n", sizeof((void*)user_data));
}

