#include <uf_defs.h>
#include <uf_cam.h>
#include <uf_udop.h>
#include <uf_oper.h>
#include <uf_path.h>
#include <uf.h>
#include <uf_exit.h>
#include <stdio.h>


/******************************************************************
  Internal user function to use the USER DEFINED operation
  The entry point name : udop
******************************************************************/
/*ARGSUSED*/
extern void udop(char *param, int *status, int parm_len)
{
  char *text = "HELIX/1";   
  char   op_name[UF_OPER_OPNAME_LEN];
  int i = 0, num_hole = 1;
  UF_UDOP_id_t		udop_id;
  UF_UDOP_purpose_t	purpose;
  UF_OPER_id_t		oper_id;
  UF_PATH_id_t		path_id;
  UF_CAM_exit_id_t    exit_id = (UF_CAM_exit_id_t)param;
  UF_initialize();
  UF_UDOP_ask_udop( exit_id, &udop_id);
  UF_UDOP_ask_oper( udop_id, &oper_id);
  UF_UDOP_ask_purpose( udop_id, &purpose);
  UF_OPER_ask_name( oper_id, op_name);
  UF_OPER_ask_path( oper_id, &path_id);
  if(purpose == UF_UDOP_GENERATE)
  {
     {
        UF_PATH_output_mode_t     output_mode = UF_PATH_OUTPUT_MODE_ABSOLUTE;
        UF_PATH_feedrate_mode_t feedrate_mode = UF_PATH_FEEDRATE_OUTPUT_MMPR;
        UF_PATH_arc_mode_t           arc_mode = UF_PATH_ARC_LINEAR;
        UF_PATH_parallel_mode_t parallel_mode = UF_PATH_PARALLEL_ZAXIS;
        UF_PATH_machine_mode_t   machine_mode = UF_PATH_MACHINE_MILL;
        UF_PATH_create_set_mode(path_id, output_mode, feedrate_mode,
                                arc_mode, parallel_mode, machine_mode, NULL );
     }
     {
        UF_PATH_spindle_on_t spindle_data;
        spindle_data.speed       = 200.0;
        spindle_data.maxrpm      = 1000.0;
        spindle_data.mode        = UF_PATH_SPINDLE_MODE_RPM;
        spindle_data.direction   = UF_PATH_DIRECTION_CLOCKWISE;
        spindle_data.speed_flag  = TRUE;
        spindle_data.maxrpm_flag = TRUE;
        spindle_data.range_flag  = FALSE;
        UF_PATH_create_spindle_on(path_id, &spindle_data, NULL);
     }
     { 
        UF_PATH_create_text(path_id, text);
     }
     for(i = 0;i < num_hole ; i++)
     {    
        /************  To input GOTO/ motion*************/
        {
           UF_PATH_linear_motion_t motion,*motion_ptr = &motion;
           motion_ptr->feed_value   = 1.0;
           motion_ptr->feed_unit    = UF_PATH_FEED_UNIT_NONE;
           motion_ptr->type         = UF_PATH_MOTION_TYPE_CUT;
           motion_ptr->tool_axis[0] = 0.0;
           motion_ptr->tool_axis[1] = 0.0;
           motion_ptr->tool_axis[2] = 1.0;
           motion_ptr->position[0]  = 1.0;
           motion_ptr->position[1]  = 2.0;
           motion_ptr->position[2]  = 3.0;
           UF_PATH_create_linear_motion(path_id, motion_ptr);
        }
        /************  To input FEDRAT/ post command *************/
     }
     { 
        UF_PATH_create_text(path_id, text);
        UF_PATH_create_pprint(path_id, text);
     }
     UF_PATH_end_tool_path(path_id); 
   }
   UF_terminate();
}

int ufusr_ask_unload(void)
{
  return(UF_UNLOAD_IMMEDIATELY);
}

