#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include<malloc.h>
#include<fcntl.h>
#include<errno.h>
#include<math.h>
#include<ctype.h>
#include<wchar.h>

#include<uf.h>
#include<uf_ui.h>
#include<uf_defs.h>
#include<uf_exit.h>
#include<uf_cfi.h>
#include<uf_part.h>
#include<uf_object_types.h>
#include<uf_disp.h>
#include<uf_modl.h>
#include<uf_curve.h>
#include<uf_defs.h>
#include<uf_exit.h>
#include<uf_csys.h>
#include<uf_styler.h>
#include<uf_mb.h> 
#include<uf_assem.h>

#include<uf_cam.h>
#include<uf_cam_prepro.h>
#include<uf_drpos.h>
#include<uf_dpud.h>
#include<uf_oper.h>
#include<uf_path.h>
#include<uf_surf_reg.h>
#include<uf_udop.h>
#include <uf_bound.h>
#include"usr_parms.h"

#define USER_PARAM_CB_COUNT (11 + 1)

void get_error(int irc);
void drive_path(void);

extern int user_parameters(int *response);
extern int init_proc(UF_UI_selection_p_t select, void *user_data);
extern int get_cut_direction(double *dir);

extern int num = 0;
int tool_pos, cut_dir, cut_type, cut_step, stepover;
double cut_angle, step_value, stepover_value;

extern double pos[3] = {0.0, 0.0, 0.0}, dir[3] = {0.0, 0.0, 0.0};
extern double direction[3] = {0.0, 0.0, 0.0};

UF_STYLER_item_value_type_t stepover_value_data;
UF_STYLER_item_value_type_t step_value_data;

UF_DRPOS_id_t drpos;

static UF_STYLER_callback_info_t USER_PARAM_cbs[USER_PARAM_CB_COUNT] = 
{
 {UF_STYLER_DIALOG_INDEX   , UF_STYLER_OK_CB           , 0, USER_PARAM_ok},
 {UF_STYLER_DIALOG_INDEX   , UF_STYLER_APPLY_CB        , 0, USER_PARAM_apply},
 {USER_PARAM_TOOL_POS      , UF_STYLER_ACTIVATE_CB     , 1, USER_PARAM_tool_pos},
 {USER_PARAM_CUT_DIR       , UF_STYLER_ACTIVATE_CB     , 1, USER_PARAM_cut_dir},
 {USER_PARAM_VECTOR        , UF_STYLER_ACTIVATE_CB     , 1, USER_PARAM_vector},
 {USER_PARAM_CUT_ANGLE     , UF_STYLER_ACTIVATE_CB     , 1, USER_PARAM_cut_angle},
 {USER_PARAM_CUT_TYPE      , UF_STYLER_ACTIVATE_CB     , 1, USER_PARAM_cut_type},
 {USER_PARAM_CUT_STEP      , UF_STYLER_ACTIVATE_CB     , 1, USER_PARAM_cut_step},
 {USER_PARAM_STEP_VALUE    , UF_STYLER_ACTIVATE_CB     , 1, USER_PARAM_step_value},
 {USER_PARAM_STEPOVER      , UF_STYLER_ACTIVATE_CB     , 1, USER_PARAM_stepover},
 {USER_PARAM_STEPOVER_VALUE, UF_STYLER_ACTIVATE_CB     , 1, USER_PARAM_stepover_value},
 {UF_STYLER_NULL_OBJECT    , UF_STYLER_NO_CB           , 0, 0 }
};


extern DllExport void dpud(char *param, int *returnCode, int rlen)
{
   int size, irc;
   double ratio = 0.0;
   double feed_value = 60.0;
   UF_CAM_exit_id_t  exit_id;
   UF_DPUD_id_t dpud_id;
   UF_DPUD_purpose_t purpose;
//   UF_DPUD_taxis_option_t taxis_option = UF_DPUD_TAXIS_CONSTANT;
   UF_DPUD_taxis_option_t taxis_option = UF_DPUD_TAXIS_VARIABLE;
//   UF_DPUD_proj_option_t  proj_option  = UF_DPUD_PROJ_CONSTANT;
   UF_DPUD_proj_option_t  proj_option  = UF_DPUD_PROJ_VARIABLE;
   UF_DRPOS_feed_use_t feed_use = UF_DRPOS_FEED_USE_CUSTOM;
   UF_DRPOS_feed_unit_t feed_unit = UF_DRPOS_FEED_UNIT_PER_MIN;

   UF_initialize();

   exit_id = (UF_CAM_exit_id_t)param;
   UF_DPUD_ask_dpud(exit_id, &dpud_id);
   UF_DPUD_ask_purpose(dpud_id, &purpose);
//   printf("Purpose = %d\n", purpose);
   size = sizeof(double)*7*3; 
   
   if(purpose == UF_DPUD_USER_PARAMS) 
   {
      user_parameters(&irc);
//    Calculate all parameters (drive points, tool axis orientation, 
//	  projection vector)
      printf("\nUSER_PARMS\n");
   }
   else if(purpose == UF_DPUD_TAXIS_PARAMS) printf("TAXIS\n");
   else if(purpose == UF_DPUD_PROJ_PARAMS) printf("PROJ\n");
   else if(purpose == UF_DPUD_INIT_PROCESSOR) 
   {
      printf("INIT\n");
      UF_DPUD_ask_taxis_option(dpud_id, &taxis_option);
      UF_DPUD_ask_proj_option(dpud_id, &proj_option);
   }
   else if(purpose == UF_DPUD_GET_USER_DATA_SIZE) 
   {
      UF_DPUD_set_user_data_size(dpud_id, size);
      printf("DATA\n");
   }
   else if(purpose == UF_DPUD_GET_NEXT) 
   { 
      UF_DPUD_ask_drpos0(dpud_id, &drpos);

      if(num == 0) 
      { 
         pos[0] = 10.0; pos[1] = 0.0; pos[2] = 20.0; 
         UF_DRPOS_set_custom_feed(drpos, feed_use, 
                                  feed_unit, feed_value);
         UF_DRPOS_set_position(drpos, pos);
         UF_DRPOS_create_first_cut(drpos, pos, dir);
      }
      else if(num < 11)
      {
         pos[0] += 0.0; pos[1] += 10.0; pos[2] = 20.0; 
         UF_DRPOS_set_position(drpos, pos);
         feed_value = 240.99;
         UF_DRPOS_set_custom_feed(drpos, feed_use, 
                                  feed_unit, feed_value);  
         UF_DRPOS_create_cut(drpos, pos, dir);
      }
      else if(num == 11)
      {
         pos[0] += 10.0; pos[1] = 0.0; pos[2] = 20.0;
//         dir[0] = 1.0; dir[1] = 0.0; dir[2] = 0.0;
//         UF_DRPOS_set_position(drpos, pos);
//         UF_DRPOS_create_cut(drpos, pos, dir);
         feed_value = 40.44;
         UF_DRPOS_set_custom_feed(drpos, feed_use, 
                                  feed_unit, feed_value);  
//         UF_DRPOS_create_stepover(drpos, pos, dir);
         UF_DRPOS_create_local_lift(drpos);
      }
      else if(num > 11)
      {
         if(num == 12) {pos[0] += 0.0; pos[1] += 0.0; pos[2] = 20.0;}
         else {pos[0] += 0.0; pos[1] += 10.0; pos[2] = 20.0;}
         UF_DRPOS_set_position(drpos, pos);
         UF_DRPOS_create_cut(drpos, pos, dir);
      }
      if(num >= 23)
      {
          UF_DRPOS_create_final_lift(drpos);
      }
//      printf("POS[1] = %.3lf\n", pos[1]);
//      printf("NEXT = %d\n", num);
      num++;
   }
   else if(purpose == UF_DPUD_GET_INTERMEDIATE) 
   {
      UF_DPUD_ask_ratio(dpud, &ratio);
      UF_DPUD_ask_drpos2(dpud_id, &drpos);
      UF_DRPOS_create_cut(drpos, pos, dir);
      UF_DPUD_ask_drpos1(dpud_id, &drpos);
      UF_DRPOS_create_cut(drpos, pos, dir);
      UF_DPUD_ask_drpos0(dpud_id, &drpos);
      UF_DRPOS_create_cut(drpos, pos, dir);
      
//      printf("INTERMEDIATE = %d\n", num);
   }
   else if(purpose == UF_DPUD_REWIND)
   {
      printf("REWIND\n");
      num = 0;
      pos[0] = 0.0; pos[1] = 0.0; pos[2] = 0.0;
   }
   else if(purpose == UF_DPUD_STOP_PROCESSOR) 
   {
      printf("STOP\n");
      num = 0;
      pos[0] = 0.0; pos[1] = 0.0; pos[2] = 0.0;
   }
   UF_terminate();
}

#include"mill_drive.h"
