extern int user_parameters(int *response)
{
   int error_code;
   error_code = UF_STYLER_create_dialog("usr_parms.dlg", USER_PARAM_cbs,
                                         USER_PARAM_CB_COUNT, NULL, response);
   return(error_code);
}

int USER_PARAM_ok(int dialog_id, void *client_data,
                  UF_STYLER_item_value_type_p_t callback_data)
{
   USER_PARAM_apply(dialog_id, client_data, callback_data);
   return(UF_UI_CB_EXIT_DIALOG); 
}

int USER_PARAM_apply(int dialog_id, void *client_data,
                     UF_STYLER_item_value_type_p_t callback_data)
{
   return(UF_UI_CB_CONTINUE_DIALOG);
}

int USER_PARAM_tool_pos(int dialog_id, void *client_data,
                        UF_STYLER_item_value_type_p_t callback_data)
{
   UF_STYLER_item_value_type_t tool_pos_data;
   tool_pos_data.reason    = UF_STYLER_ACTIVATE_REASON;
   tool_pos_data.item_id   = USER_PARAM_TOOL_POS;
   tool_pos_data.item_attr = UF_STYLER_VALUE;
   tool_pos_data.indicator = UF_STYLER_INTEGER_VALUE;
   tool_pos_data.count     = 1;
   UF_STYLER_ask_value(dialog_id, &tool_pos_data);
   tool_pos = tool_pos_data.value.integer;
   return(UF_UI_CB_CONTINUE_DIALOG);
}

int USER_PARAM_cut_dir(int dialog_id, void *client_data,
                       UF_STYLER_item_value_type_p_t callback_data)
{
   UF_STYLER_item_value_type_t cut_dir_data;
   cut_dir_data.reason    = UF_STYLER_ACTIVATE_REASON;
   cut_dir_data.item_id   = USER_PARAM_CUT_DIR;
   cut_dir_data.item_attr = UF_STYLER_VALUE;
   cut_dir_data.indicator = UF_STYLER_INTEGER_VALUE;
   cut_dir_data.count     = 1;
   UF_STYLER_ask_value(dialog_id, &cut_dir_data);
   cut_dir = cut_dir_data.value.integer;
   return(UF_UI_CB_CONTINUE_DIALOG);
}

int USER_PARAM_vector(int dialog_id, void *client_data,
                      UF_STYLER_item_value_type_p_t callback_data)
{
   int irc;
   irc = get_cut_direction(direction);
   if(irc) return(UF_UI_CB_EXIT_DIALOG);  
   else return(UF_UI_CB_CONTINUE_DIALOG);
}     
  
int USER_PARAM_cut_angle(int dialog_id, void *client_data,
                         UF_STYLER_item_value_type_p_t callback_data)
{ 
   UF_STYLER_item_value_type_t cut_angle_data;
   cut_angle_data.reason    = UF_STYLER_ACTIVATE_REASON;
   cut_angle_data.item_id   = USER_PARAM_CUT_ANGLE;
   cut_angle_data.item_attr = UF_STYLER_VALUE;
   cut_angle_data.indicator = UF_STYLER_REAL_VALUE;
   cut_angle_data.count     = 1;
   UF_STYLER_ask_value(dialog_id, &cut_angle_data);
   cut_angle = cut_angle_data.value.real;
   return(UF_UI_CB_CONTINUE_DIALOG);
}

int USER_PARAM_cut_type(int dialog_id, void *client_data,
                        UF_STYLER_item_value_type_p_t callback_data)
{
   UF_STYLER_item_value_type_t cut_type_data;
   cut_type_data.reason    = UF_STYLER_ACTIVATE_REASON;
   cut_type_data.item_id   = USER_PARAM_CUT_TYPE;
   cut_type_data.item_attr = UF_STYLER_VALUE;
   cut_type_data.indicator = UF_STYLER_INTEGER_VALUE;
   cut_type_data.count     = 1;
   UF_STYLER_ask_value(dialog_id, &cut_type_data);
   cut_type = cut_type_data.value.integer;
   return(UF_UI_CB_CONTINUE_DIALOG);
}

int USER_PARAM_cut_step(int dialog_id, void *client_data,
                        UF_STYLER_item_value_type_p_t callback_data)
{
   double d_step;
   UF_STYLER_item_value_type_t cut_step_data;
   cut_step_data.reason    = UF_STYLER_ACTIVATE_REASON;
   cut_step_data.item_id   = USER_PARAM_CUT_STEP;
   cut_step_data.item_attr = UF_STYLER_VALUE;
   cut_step_data.indicator = UF_STYLER_INTEGER_VALUE;
   cut_step_data.count     = 1;
   UF_STYLER_ask_value(dialog_id, &cut_step_data);
   cut_step = cut_step_data.value.integer;
   step_value_data.item_id = USER_PARAM_STEP_VALUE;
   step_value_data.item_attr = UF_STYLER_LABEL;
   if(cut_step == 0) 
   {
      step_value_data.value.string = "Number";
      d_step = 10.0;
   }
   else if(cut_step == 1) 
   {
      step_value_data.value.string = "Tolerance";
      d_step = 0.01;
   }
   UF_STYLER_set_value(dialog_id, &step_value_data);
   step_value_data.item_attr = UF_STYLER_VALUE;
   step_value_data.value.real = d_step;
   UF_STYLER_set_value(dialog_id, &step_value_data);  
   return(UF_UI_CB_CONTINUE_DIALOG);
}

int USER_PARAM_step_value(int dialog_id, void *client_data,
                          UF_STYLER_item_value_type_p_t callback_data)
{
   step_value_data.reason    = UF_STYLER_ACTIVATE_REASON;
   step_value_data.item_id   = USER_PARAM_STEP_VALUE;
   step_value_data.item_attr = UF_STYLER_VALUE;
   step_value_data.indicator = UF_STYLER_REAL_VALUE;
   step_value_data.count     = 1;
   UF_STYLER_ask_value(dialog_id, &step_value_data);
   step_value = step_value_data.value.real;
   return(UF_UI_CB_CONTINUE_DIALOG);
}

int USER_PARAM_stepover(int dialog_id, void *client_data,
                        UF_STYLER_item_value_type_p_t callback_data)
{
   double d_step;
   UF_STYLER_item_value_type_t stepover_data;
   stepover_data.reason    = UF_STYLER_ACTIVATE_REASON;
   stepover_data.item_id   = USER_PARAM_STEPOVER;
   stepover_data.item_attr = UF_STYLER_VALUE;
   stepover_data.indicator = UF_STYLER_INTEGER_VALUE;
   stepover_data.count     = 1;
   UF_STYLER_ask_value(dialog_id, &stepover_data);
   stepover = stepover_data.value.integer;
   stepover_value_data.item_id = USER_PARAM_STEPOVER_VALUE;
   stepover_value_data.item_attr = UF_STYLER_LABEL;
   if(stepover == 0) 
   {
      stepover_value_data.value.string = "Number";
      d_step = 10.0;
   }
   else if(stepover == 1) 
   {
      stepover_value_data.value.string = "Scallop";
      d_step = 0.05;
   }
   UF_STYLER_set_value(dialog_id, &stepover_value_data);
   stepover_value_data.item_attr = UF_STYLER_VALUE;
   stepover_value_data.value.real = d_step;
   UF_STYLER_set_value(dialog_id, &stepover_value_data);  
   return(UF_UI_CB_CONTINUE_DIALOG);
}

int USER_PARAM_stepover_value(int dialog_id, void *client_data,
                              UF_STYLER_item_value_type_p_t callback_data)
{
   stepover_value_data.reason    = UF_STYLER_ACTIVATE_REASON;
   stepover_value_data.item_id   = USER_PARAM_STEPOVER_VALUE;
   stepover_value_data.item_attr = UF_STYLER_VALUE;
   stepover_value_data.indicator = UF_STYLER_REAL_VALUE;
   stepover_value_data.count     = 1;
   UF_STYLER_ask_value(dialog_id, &stepover_value_data);
   stepover_value = stepover_value_data.value.real;
   return(UF_UI_CB_CONTINUE_DIALOG);
}

extern int ufusr_ask_unload(void){return(UF_UNLOAD_SEL_DIALOG);}

extern void ufusr_cleanup(void){return;}

void get_error(int irc)
{
   char err_msg[UF_UI_MAX_STRING_LEN+1];
   char msg[133];
   char fail_message[133];
   int  len;
   UF_get_fail_message(irc, fail_message);
   sprintf(err_msg, "error %d: %s", irc, fail_message);
   len = strlen(err_msg);
   len = (len < 131) ? len : 131;
   strncpy (msg, err_msg, len);
   msg[len+1] = '\000';
   uc1601(err_msg, TRUE);
}

/* Function for set selection mask */
extern int init_proc(UF_UI_selection_p_t select, void* user_data)
{
   int num_triples = 2;
   UF_UI_mask_t mask_triples[] = {UF_boundary_type, 0, 0,
                                  UF_cam_body_type, 0, 0};

   if(UF_UI_set_sel_mask(select, UF_UI_SEL_MASK_CLEAR_AND_ENABLE_SPECIFIC,
                                  num_triples, mask_triples) == 0)
   {
      return (UF_UI_SEL_SUCCESS);
   }
   else return (UF_UI_SEL_FAILURE);
}

extern int get_cut_direction(double *direction)
{
   char *message = "Specify cut direction";
   int mode = UF_UI_LINE_ENDPOINT;
   int display_conehead = UF_UI_DISP_TEMP_VECTOR;
   int response;
   double origin[3];

   UF_UI_specify_vector(message, &mode, display_conehead, dir,
                        origin, &response);
   if(response == UF_UI_BACK || response == UF_UI_CANCEL) return 1;
   else return 0;
}